/*****************************************************************************
*
* @brief BEAR SoC memory map and defines.
*
* @author alexander.kozlov@cloudbear.ru, denis.ivanov@cloudbear.ru
*
* Copyright (c) 2018 CloudBEAR LLC - http://www.cloudbear.ru/
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions
* are met:
*
*   Redistributions of source code must retain the above copyright
*   notice, this list of conditions and the following disclaimer.
*
*   Redistributions in binary form must reproduce the above copyright
*   notice, this list of conditions and the following disclaimer in the
*   documentation and/or other materials provided with the
*   distribution.
*
*   Neither the name of CloudBEAR nor the names of
*   its contributors may be used to endorse or promote products derived
*   from this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
* "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
* LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
* A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
* OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
* LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
* THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
* OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
******************************************************************************/

#ifndef __BEAR_SOC_H_
#define __BEAR_SOC_H_

/* CLINT base address */
#define BEAR_CLINT_BASE 0x02000000
#define BEAR_PLIC_BASE 0x0C000000
#define RISCV_IEM   *((volatile unsigned int *)0x0C002000)
#define RISCV_THR   *((volatile unsigned int *)0x0C200000)
#define RISCV_ICC   *((volatile unsigned int *)0x0C200004)
#define RISCV_IPM   *((volatile unsigned int *)0x0C001000)
#define RISCV_PRI13 *((volatile unsigned int *)0x0C000034)
#define RISCV_PRI14 *((volatile unsigned int *)0x0C000038)

/* Timer configuration */
#define RISCV_MTIME_BASE (BEAR_CLINT_BASE + 0xBFF8)
#define RISCV_MTIMECMP_BASE (BEAR_CLINT_BASE + 0x4000)
#define RISCV_MTIMECMP(hartid) (RISCV_MTIMECMP_BASE + 0x008 * (hartid))
#define RISCV_PRI(num) *((volatile unsigned int *)(BEAR_PLIC_BASE +0x004*(num)))


#endif /* __BEAR_SOC_H_ */ 
