/**
  ******************************************************************************
  * @file    novgorod_crc_defs.h
  * @author  Phyton Application Team
  * @version V1.0.0
  * @date
  * @brief   This file contains all the Special Function Registers definitions
  *          for the CRC peripheral unit used in the Milandr NOVGOROD
  *          microcontrollers.
  ******************************************************************************
  * @copy
  *
  * THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
  * WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
  * TIME. AS A RESULT, PHYTON SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
  * OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
  * FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
  * CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
  *
  * <h2><center>&copy; COPYRIGHT 2010 Phyton</center></h2>
  ******************************************************************************
  * FILE novgorod_crc_defs.h
  */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __NOVGOROD_CRC_DEFS_H
#define __NOVGOROD_CRC_DEFS_H

/** @addtogroup __CMSIS CMSIS
  * @{
  */

/** @addtogroup __NOVGOROD_Peripheral_Units NOVGOROD Peripheral Units
  * @{
  */

/** @defgroup Periph_CRC CRC
  * @{
  */

/** @defgroup Periph_CRC_Data_Structures Data Structures
  * @{
  */

/** @defgroup Periph_CRC_TypeDef CRC_TypeDef
  * @{
  */

typedef struct {
  __IO uint32_t CTRL;
  __IO uint32_t STAT;
  __IO uint32_t DATAI;
  __IO uint32_t VAL;
  __IO uint32_t POL;
} CRC_TypeDef;

/** @} */ /* End of group Periph_CRC_TypeDef */

/** @} */ /* End of group Periph_CRC_Data_Structures */

/** @} */ /* End of group Periph_CRC */

/** @} */ /* End of group __NOVGOROD_Peripheral_Units */

/** @} */ /* End of group __CMSIS */

#endif /* __NOVGOROD_CRC_DEFS_H */

/******************* (C) COPYRIGHT 2010 Phyton *********************************
*
* END OF FILE novgorod_crc_defs.h */
