typedef struct {
  __IO uint32_t CMD_CTRL_CNT;
  __IO uint32_t INT_FLAG;
  __IO uint32_t INT_ENABLE;
  __IO uint32_t ALU_STAT_CTRL;
  __IO uint32_t M_SCTRL;

} ALU_TypeDef;

#define MEM_CMD   (((volatile unsigned long *) 0x60001000))
#define MEM_REG	  (((volatile unsigned long *) 0x60002000))


typedef struct {
  __IO uint32_t TRANSFORM_0;
  __IO uint32_t TRANSFORM_1;
  __IO uint32_t TRANSFORM_2;
  __IO uint32_t TRANSFORM_3;
  __IO uint32_t TABLE_CHANGE_0;
  __IO uint32_t TABLE_CHANGE_1;
  __IO uint32_t TABLE_CHANGE_2;
  __IO uint32_t TABLE_CHANGE_3;
  __IO uint32_t SETUP;
  __IO uint32_t M_SCTRL;

} L_BLOCK_TypeDef;


typedef struct {
  __IO uint32_t TRANSFORM_0;
  __IO uint32_t TRANSFORM_1;
  __IO uint32_t TRANSFORM_2;
  __IO uint32_t TRANSFORM_3;
  __IO uint32_t TRANSFORM_4;
  __IO uint32_t TRANSFORM_5;
  __IO uint32_t TRANSFORM_6;
  __IO uint32_t TRANSFORM_7;
  __IO uint32_t TABLE_CHANGE;
  __IO uint32_t M_SCTRL;

} S_BLOCK_TypeDef;

typedef struct {
  __IO uint32_t TRANSFORM_0;
  __IO uint32_t TRANSFORM_1;
  __IO uint32_t TRANSFORM_2;
  __IO uint32_t TRANSFORM_3;
  __IO uint32_t TRANSFORM_4;
  __IO uint32_t TRANSFORM_5;
  __IO uint32_t TRANSFORM_6;
  __IO uint32_t TRANSFORM_7;
  __IO uint32_t TRANSFORM_8;
  __IO uint32_t TRANSFORM_9;
  __IO uint32_t TRANSFORM_10;
  __IO uint32_t TRANSFORM_11;
  __IO uint32_t TRANSFORM_12;
  __IO uint32_t TRANSFORM_13;
  __IO uint32_t TRANSFORM_14;
  __IO uint32_t TRANSFORM_15;
  __IO uint32_t MUX_SET;
  __IO uint32_t MUX_VAL;

} P_BYTE_TypeDef;

typedef struct {
  __IO uint32_t TRANSFORM_0;
  __IO uint32_t TRANSFORM_1;
  __IO uint32_t TRANSFORM_2;
  __IO uint32_t TRANSFORM_3;
  __IO uint32_t MUX_SET;
  __IO uint32_t MUX_VAL;

} P_BIT_TypeDef;


typedef struct {
  __IO uint32_t CONTROL;
  __IO uint32_t SEED_0;
  __IO uint32_t SEED_1;
  __IO uint32_t SEED_2;
  __IO uint32_t SEED_3;
  __IO uint32_t LFSR_0;
  __IO uint32_t LFSR_1;
  __IO uint32_t LFSR_2;
  __IO uint32_t LFSR_3;
  __IO uint32_t RAND_0;
  __IO uint32_t RAND_1;
  __IO uint32_t RAND_2;
  __IO uint32_t RAND_3;
  __IO uint32_t POLY_0;
  __IO uint32_t POLY_1;
  __IO uint32_t POLY_2;
  __IO uint32_t POLY_3;
  __IO uint32_t PERIODS;
  __IO uint32_t MASK_0;
  __IO uint32_t MASK_1;
  __IO uint32_t MASK_2;
  __IO uint32_t MASK_3;
  
} NOISE_GEN_TypeDef;

typedef struct {
  __IO uint32_t state_reg;
  __IO uint32_t real_time;
  uint32_t      RESERVED7; 
  __IO uint32_t int_mask;
  __IO uint32_t k_res_mask;
  uint32_t      RESERVED8; 
  __IO uint32_t enable;
  __IO uint32_t mesh_key7;
  __IO uint32_t mesh_key6;
  __IO uint32_t mesh_key5;
  __IO uint32_t mesh_key4;
  __IO uint32_t mesh_key3;
  __IO uint32_t mesh_key2;
  __IO uint32_t mesh_key1;
  __IO uint32_t mesh_key0;
  __IO uint32_t mesh_init1;
  __IO uint32_t mesh_init0;
  __IO uint32_t meshcntr;
   
} SENSORS_TypeDef;

typedef struct {
  __IO uint32_t CLK_CNTR_STAT;
  __IO uint32_t ALARM_SHIFT_RST;
  __IO uint32_t ALARM_SHIFT_INT;
  __IO uint32_t PREG_REG_0;
  __IO uint32_t PREG_REG_1;

} CLK_MEASURE_TypeDef;

typedef struct {
  __IO uint32_t STAT_CTRL_REG;
  __IO uint32_t INT_CTRL_REG;
  __IO uint32_t CLK_DIV_REG;
  __IO uint32_t PAUSE_REG;
  __IO uint32_t OUTPUT_REG;
  __IO uint32_t PAUSE_CNT_REG;
  __IO uint32_t TEMP_REG;
} RANDOM_TypeDef; 
