/**
  ******************************************************************************
  * @file    novgorod_comp_defs.h
  * @author  Phyton Application Team
  * @version V1.0.0
  * @date
  * @brief   This file contains all the Special Function Registers definitions
  *          for the I2C peripheral unit used in the Milandr NOVGOROD
  *          microcontrollers.
  ******************************************************************************
  * @copy
  *
  * THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
  * WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
  * TIME. AS A RESULT, PHYTON SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
  * OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
  * FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
  * CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
  *
  * <h2><center>&copy; COPYRIGHT 2010 Phyton</center></h2>
  ******************************************************************************
  * FILE novgorod_i2c_defs.h
  */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __NOVGOROD_I2C_DEFS_H
#define __NOVGOROD_I2C_DEFS_H

/** @addtogroup __CMSIS CMSIS
  * @{
  */

/** @addtogroup __NOVGOROD_Peripheral_Units NOVGOROD Peripheral Units
  * @{
  */

/** @defgroup Periph_I2C I2C
  * @{
  */

/** @defgroup Periph_I2C_Data_Structures Data Structures
  * @{
  */

/** @defgroup Periph_I2C_TypeDef COMP_TypeDef
  * @{
  */

typedef struct {
  __IO uint32_t PRL;
  __IO uint32_t PRH;
  __IO uint32_t CTR;
  __IO uint32_t RXD;
  __IO uint32_t STA;
  __IO uint32_t TXD;
  __IO uint32_t CMD;
} I2C_TypeDef;

#endif /* __NOVGOROD_COMP_DEFS_H */

/******************* (C) COPYRIGHT 2010 Phyton *********************************
*
* END OF FILE novgorod_comp_defs.h */
